<?php

include("/usr/local/cpanel/php/cpanel.php");

define(BUF_SIZ, 2048);        # max buffer size
define(FD_WRITE, 0);        # stdin
define(FD_READ, 1);        # stdout
define(FD_ERR, 2);        # stderr


function get_line_with_string($file_name, $str) {
    $lines = file($file_name);
    foreach ($lines as $lineNumber => $line) {
        if (strpos($line, $str) !== false) {
            return $line;
        }
    }
    return "";
}

function get_line_with_exact_match($file_name, $str) {
    $lines = file($file_name);
    foreach ($lines as $lineNumber => $line) {
	$newline = explode(':', $line);
        if (strcmp($newline[0], $str) == 0) {
            return $line;
        }
    }
    return "";
}   

function get_subset_array_from_file($file_name, $dom_tuple) {
	$lines = file($file_name);
	$newlines = array();
	foreach ($lines as $line) {
		list($newline, $newttl, $newurl) = explode(':', trim($line), 3);
		list($dom, $ttl, $url) = explode(':', $dom_tuple);
		if(strcmp($newline . $newurl, $dom . $url) == 0) {
			continue;
		}
		array_push($newlines, trim($line));
	}
	array_push($newlines, $dom_tuple);
	return $newlines;
}


function get_line_with_exact_match_xsplit($file_name, $str) {
    $lines = file($file_name);
    foreach ($lines as $lineNumber => $line) {
        if (strcmp(trim($line), $str) == 0) {
            return $line;
        }
    }
    return "";
}

function get_enabled_array_from_file_xsplit($file_name, $dom) {
        $lines = file($file_name);
        $newlines = array();
        foreach ($lines as $line) { 
                if(strcmp(trim($line), trim($dom)) == 0) {
                        continue;
                }
                array_push($newlines, trim($line));
        }
        return $newlines;
}

function remove_entry_from_file_xsplit($file_name, $domurl) {
	$lines = file($file_name);
	$newlines = array();
	foreach ($lines as $line) {
		list($dom, $ttl, $url) = explode(':', $line, 3);
		if (strcmp(trim($dom . ':' . $url), trim($domurl)) == 0) {
			continue;
		}
		array_push($newlines, trim($line));
	}
	return $newlines;
}

function proc_exec($cmd, &$out)
{
    $descriptorspec = array(
        0 => array("pipe", "r"),
        1 => array("pipe", "w"),
        2 => array("pipe", "w")
    );
    $ptr = proc_open($cmd, $descriptorspec, $pipes, NULL, $_ENV);
    if (!is_resource($ptr))
        return false;

    while (($buffer = fgets($pipes[FD_READ], BUF_SIZ)) != NULL
            || ($errbuf = fgets($pipes[FD_ERR], BUF_SIZ)) != NULL) {
        if (!isset($flag)) {
            $pstatus = proc_get_status($ptr);
            $first_exitcode = $pstatus["exitcode"];
            $flag = true;
        }
        if (strlen($buffer))
		$out = $buffer;
        if (strlen($errbuf))
            echo "ERR: " . $errbuf;
    }

    foreach ($pipes as $pipe)
        fclose($pipe);

    /* Get the expected *exit* code to return the value */
    $pstatus = proc_get_status($ptr);
    if (!strlen($pstatus["exitcode"]) || $pstatus["running"]) {
        /* we can trust the retval of proc_close() */
        if ($pstatus["running"])
            proc_terminate($ptr);
        $ret = proc_close($ptr);
    } else {
        if ((($first_exitcode + 256) % 256) == 255
                && (($pstatus["exitcode"] + 256) % 256) != 255)
            $ret = $pstatus["exitcode"];
        elseif (!strlen($first_exitcode))
            $ret = $pstatus["exitcode"];
        elseif ((($first_exitcode + 256) % 256) != 255)
            $ret = $first_exitcode;
        else
            $ret = 0; /* we "deduce" an EXIT_SUCCESS ;) */
        proc_close($ptr);
    }

    return $buffer;
}


function tune_varnish($action, &$out){

        proc_exec($action, $out);
}

function retrieve_current_ttl(&$out) {
        tune_varnish("/usr/bin/python /scripts/getttl", $out);
}

function retrieve_current_static_ttl(&$out) {
        tune_varnish("/usr/bin/python /scripts/getstaticttl", $out);
}



$cpanel = &new CPANEL();

$res = $cpanel->api1('Branding', 'include', array('stdheader.html') );
print $res['cpanelresult']['data']['result'];

$user=array($_SERVER['REMOTE_USER']);

$doms_list = array();

$doms1 = $cpanel->api2("DomainLookup","getbasedomains", $user);
for ($i = 0; $i < sizeof($doms1["cpanelresult"]["data"]) ; $i++) {
        array_push($doms_list, $doms1["cpanelresult"]["data"][$i]["domain"]);
}

$doms2 = $cpanel->api2("SubDomain", "listsubdomains", $user);
for ($i = 0; $i < sizeof($doms2["cpanelresult"]["data"]) ; $i++) {
        array_push($doms_list, $doms2["cpanelresult"]["data"][$i]["domain"]);
}

$dom_count = sizeof($doms_list);

$server_varnish_home = "/etc/varnish";

$varnish_home = $_SERVER['HOME'] . "/varnish";
$varnish_go = "$varnish_home/process.go";
$varnish_disabled = "$varnish_home/disable_domains.txt";
$varnish_gun_ttl = "$varnish_home/gun.txt";

$h = fopen($varnish_disabled, "r");
if($h) {
        $all_disabled_domains = fread($h, filesize($varnish_disabled));
}
fclose($h);

$all_varnish_ttl = '';
$all_varnish_gun_ttl = '';


if (file_exists($varnish_gun_ttl)) {
        $h = fopen($varnish_gun_ttl, "r");
        if ($h) {
                if (filesize($varnish_gun_ttl) > 0) {
                        $all_varnish_gun_ttl = fread($h, filesize($varnish_gun_ttl));
                }
        }
        fclose($h);
}

$gun_size = strlen(trim($all_varnish_gun_ttl));


if(isset($_POST) && sizeof($_POST) > 0) {

 if(isset($_POST["gundown"])) {

	$gun_array = array();

	if (isset($_POST["gundown"])) {
		$domain = trim($_POST["gundown"]);
	}
	if (isset($_POST["url"])) {
		$url = trim($_POST["url"]);
	}

	if (isset($_POST["ttl"])) {
		$ttl = abs(intval(trim($_POST["ttl"])));
	}

	array_push($gun_array, $domain . ':' . $ttl . ':' . $url);

	if (!is_dir($varnish_home)) { mkdir($varnish_home);}

	if(!file_exists($varnish_gun_ttl)) {
		$f = fopen($varnish_gun_ttl, "w+");	
		if ($f) {
			fclose($f);
			}
	}

	$gun_ttl_array = get_subset_array_from_file($varnish_gun_ttl, $gun_array[0]);

	$gunner = fopen($varnish_gun_ttl, "w+");
	if($gunner) {
		foreach( $gun_ttl_array as $entry ) {
			if (strlen($entry) > 0) {
				fwrite($gunner, trim($entry). "\n");
			}
		}
		fclose($gunner);
	}

        $hh = fopen($varnish_go, "w+");
        if ($hh) {
                fwrite($hh, "go");
        fclose($hh);
        }

 }

	else if(isset($_POST["hidden"])) {
		$gunner_final_array = array();
		list($dom, $ttl, $url) = explode(':', $_POST["hidden"], 3);
		$gunner_final_array = remove_entry_from_file_xsplit($varnish_gun_ttl, $dom . ':' . $url);
		$gunner = fopen($varnish_gun_ttl, "w+");
		if($gunner) {
			foreach( $gunner_final_array as $entry ) {
				if (strlen($entry) > 0) {
					fwrite($gunner, trim($entry). "\n");
				}
			}
			fclose($gunner);
		}
		$hh = fopen($varnish_go, "w+");
		if ($hh) {
			fwrite($hh, "go");
		fclose($hh);
		}

 }
}

?>
<?php include("UNIXyVarnish.menu.html"); ?>

<div class="body-content">
<center><h1>HTTP Gun: Aggressive Page Caching</h1></center>
</div>

<center>
<?php
$uri = $_SERVER['REQUEST_URI'];
echo "<form action=\"$uri\" method=\"post\">";
echo "www.<select name=\"gundown\">";
foreach ($doms_list as $dom) {
	echo "<option value=\"$dom\">$dom</option>";
}
echo "</select>";
echo "<input type=\"input\" name=\"url\" value=\"/\">";
echo "<input type=\"input\" name=\"ttl\" value=\"15\">";
echo "<input type=\"submit\" name=\"addgun\" value=\"submit\"> <strong><font color=\"red\">Beta</font></strong>";
echo "</form>";
?>

<br /><br />

<table border="1" style="background-color:white;border:1px dotted black;width:80%;border-collapse:collapse; padding-left: 30px;">
<tr style="background-color:orange;color:white;">
<th style="padding:3px;">Domain</th>
<th style="padding:3px;">URL</th>
<th style="padding:3px;">Page TTL (sec) </th>
<th style="padding:10px;"><b>X</b></th>
</tr>
<?

if ( $gun_size <=0 ) {

print("<tr>");
echo "<td style=\"padding:3px;\">--</td><td style=\"padding:3px;\">--</td> <td style=\"padding:3px;\">-- </td><td>--</td>";
print("</tr>");

}

else {

$guns_array = get_enabled_array_from_file_xsplit($varnish_gun_ttl, "dummydomain");

$gun_count = count($guns_array);

for ($i = 0; $i < $gun_count; $i++) {

echo sprintf("<form method=\"post\" action=\"%s\">", $_SERVER['SCRIPT_NAME']);
list($dom, $dom_ttl, $dom_url) = explode(':', $guns_array[$i], 3);

if ( substr($dom, 0, 5) === "mail." || substr($dom, 0, 4) === "ftp." || substr($dom, 0, 2) === "*.") {
        continue;
}

print("<tr>");
echo sprintf("<td style=\"padding:3px;\"><b><a target=\"_blank\" href=\"http://%s\">%s</a></b></td><td style=\"padding:3px; align-text: center;\">%s</td><td style=\"padding:3px; text-align: center;\"><b>%s</b></td> <td style=\"padding:3px; text-align: center;\"><input type=\"submit\" name=\"Remove\" value=\"Remove\" /><input type=\"hidden\" name=\"hidden\" value=\"%s\" /></td>", $dom, $dom, $dom_url, $dom_ttl, $guns_array[$i]);
print("</tr>");
echo "</form>";
}
}
?>
</table>
<br />
<!-- <input type="submit" name="Change" /> -->
</center>
<br /><br />
<center>Changes made do NOT take effect immediately. Check with support on run frequency.</center>
<br /><br />
<?php
$res = $cpanel->api1('Branding', 'include', array('stdfooter.html') );
print $res['cpanelresult']['data']['result'];
$cpanel->end();
