<?php

include("/usr/local/cpanel/php/cpanel.php");

function get_line_with_exact_match($file_name, $str) {
    $lines = file($file_name);
    foreach ($lines as $lineNumber => $line) {
        $newline = explode(':', $line);
        if (strcmp($newline[0], $str) == 0) {
            return $line;
        }
    }
    return "";
}

function get_line_with_exact_match_xsplit($file_name, $str) {
    $lines = file($file_name);
    foreach ($lines as $lineNumber => $line) {
        if (strcmp(trim($line), $str) == 0) {
            return $line;
        }
    }
    return "";
}

function get_disabled_array_from_file_xsplit($file_name, $dom) {
        $lines = file($file_name);
        $newlines = array();
        foreach ($lines as $line) {
                if(strcmp($line, $dom) == 0) {
                        continue;
                }
                array_push($newlines, trim($line));
        }
        array_push($newlines, $dom);
        return $newlines;
}

function get_enabled_array_from_file_xsplit($file_name, $dom) {
        $lines = file($file_name);
        $newlines = array();
        foreach ($lines as $line) {
                if(strcmp(trim($line), trim($dom)) == 0) {
                        continue;
                }
                array_push($newlines, trim($line));
        }
        return $newlines;
}


$cpanel = &new CPANEL();

$res = $cpanel->api1('Branding', 'include', array('stdheader.html') );
print $res['cpanelresult']['data']['result'];

$user=array($_SERVER['REMOTE_USER']);

$doms_list = array();

$doms1 = $cpanel->api2("DomainLookup","getbasedomains", $user);
for ($i = 0; $i < sizeof($doms1["cpanelresult"]["data"]) ; $i++) {
        array_push($doms_list, $doms1["cpanelresult"]["data"][$i]["domain"]);
}

$doms2 = $cpanel->api2("SubDomain", "listsubdomains", $user);
for ($i = 0; $i < sizeof($doms2["cpanelresult"]["data"]) ; $i++) {
        array_push($doms_list, $doms2["cpanelresult"]["data"][$i]["domain"]);
}

$dom_count = sizeof($doms_list);



/* Adapted from http://giantdorks.org/alain/exploring-methods-to-purge-varnish-cache/ */
function readit($sock, $verbose) {
    // if (!$verbose) { return; }
    while ($sockstr = fgets($sock,1024)) {
      $str .= "rcv: " . $sockstr . "<br>";
    }
    if ($verbose) { echo "$str\n"; }
  }
 
function put($sock, $verbose, $str) {
    fwrite ($sock, $str . "\r\n");
    if ($verbose) { echo "send: $str <br>\n"; }
    readit($sock, $verbose);
}

function send_purge($dom_array) {
 
  $ip = "127.0.0.1";
  $port = "6082";
 
  $timeout = 1;
  $verbose = 0;
 
  # inits
  $sock = fsockopen ($ip,$port,$errno, $errstr,$timeout);
  if (!$sock) { echo "connections failed $errno $errstr"; exit; }
 
  if ( sizeof($dom_array) <=0 ) { echo "No doms to purge"; exit; }
 
  stream_set_timeout($sock,$timeout);
 
  foreach ($dom_array as $domain) {
        $pcommand = 'ban req.http.host ~ ';
        $pcommand .= '"^(www.)?' . $domain . '$"';
  	put ($sock, $verbose, $pcommand);
  }
  put ($sock, $verbose, "quit");
  fclose ($sock);
}

$varnish_home = $_SERVER['HOME'] . "/varnish";
$varnish_go = "$varnish_home/process.go";
$varnish_disabled = "$varnish_home/disable_domains.txt";
$varnish_dynamic_ttl = "$varnish_home/dynamic_ttl.txt";
$varnish_static_ttl = "$varnish_home/static_ttl.txt";

$h = fopen($varnish_disabled, "r");
if($h) {
        $all_disabled_domains = fread($h, filesize($varnish_disabled));
}
fclose($h);

$all_varnish_ttl = '';

$h = fopen($varnish_dynamic_ttl, "r");
if ($h) {
	$all_varnish_ttl = fread($h, filesize($varnish_dynamic_ttl));
}
fclose($h);

$h = fopen($varnish_static_ttl, "r");
if ($h) {
	$all_varnish_ttl .= fread($h, filesize($varnish_static_ttl));
}
fclose($h);

if(isset($_POST) && sizeof($_POST) > 0) {
	$purge_array = array();
	foreach ($_POST as $key => $item) {
		if (strlen(stristr($item, "toggles")) > 0) {
                        array_push($purge_array, trim(str_replace('_', '.', $key)));
                }
	}
	send_purge($purge_array);


}

?>

<?php include("UNIXyVarnish.menu.html"); ?>

<div class="body-content">
<center><h1>Purge Varnish Cache</h1></center>
</div>

<form method="post" action="<?php $_SERVER['SCRIPT_NAME']?>">
<center>
<table border="1" style="background-color:white;border:1px dotted black;width:80%;border-collapse:collapse; padding-left: 30px;">
<tr style="background-color:orange;color:white;">
<th style="padding:3px;">Domain</th><th style="padding:3px;">Purge Toggle</th>
</tr>
<?

for ($i = 0; $i < $dom_count; $i++) {

$dom = $doms_list[$i];

if ( substr($dom, 0, 5) === "mail." || substr($dom, 0, 4) === "ftp." || substr($dom, 0, 2) === "*." ) {
        continue;
}

if (strlen(get_line_with_exact_match_xsplit($varnish_disabled, $dom)) > 0) {
        $disabled = "<font color=\"Red\">Disabled</front>";
        $disabled_checked="CHECKED";
        $server_default="";
	continue;
}
else if (strlen(get_line_with_exact_match($varnish_dynamic_ttl, $dom)) > 0 || strlen(get_line_with_exact_match($varnish_static_ttl, $dom)) > 0) {
	$disabled = "<font color=\"blue\">User Settings</color>";
	$disabled_checked="";
	$server_default="CHECKED";
}
else {
        $disabled = "<font color=\"green\">Server Default</font>";
        $disabled_checked="";    
        $server_default="CHECKED";
}

print("<tr>");
print("<td style=\"padding:3px;\"><b><a target=\"_blank\" href=\"http://" . $dom . "\">" . $dom . "</a></b></td><td style=\"text-align: center;padding:3px;\"><input type=\"checkbox\" name=\"" . $dom . "\" value=\"toggles\" /></td>");
print("</tr>");
}

?>
</table>
<br />
<input type="submit" name="Change" />
</center>
</form>
<br /><br />
<center>Purging takes effect immediately upon submitting the request.</center>
<br /><br />
<?php

/*
	$h = fopen("/home/ultrava2/varnish/test.out", "w+");
	fwrite($h, "aha", strlen("aha"));
	fclose($h);
	print_r($doms);
*/


$h = fopen($varnish_disabled, "r");
if($h) {
	$out = fread($h, filesize($varnish_disabled));
}
fclose($h);
?>
<?php
$res = $cpanel->api1('Branding', 'include', array('stdfooter.html') );
print $res['cpanelresult']['data']['result'];
$cpanel->end();
